float A_inv[16][16] = {{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
					   {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
					   {-3, 3, 0, 0, -2, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
					   {2, -2, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
					   {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
					   {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},
					   {0, 0, 0, 0, 0, 0, 0, 0, -3, 3, 0, 0, -2, -1, 0, 0},
					   {0, 0, 0, 0, 0, 0, 0, 0, 2, -2, 0, 0, 1, 1, 0, 0},
					   {-3, 0, 3, 0, 0, 0, 0, 0, -2, 0, -1, 0, 0, 0, 0, 0},
					   {0, 0, 0, 0, -3, 0, 3, 0, 0, 0, 0, 0, -2, 0, -1, 0},
					   {9, -9, -9, 9, 6, 3, -6, -3, 6, -6, 3, -3, 4, 2, 2, 1},
					   {-6, 6, 6, -6, -3, -3, 3, 3, -4, 4, -2, 2, -2, -2, -1, -1},
					   {2, 0, -2, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0},
					   {0, 0, 0, 0, 2, 0, -2, 0, 0, 0, 0, 0, 1, 0, 1, 0},
					   {-6, 6, 6, -6, -4, -2, 4, 2, -3, 3, -3, 3, -2, -1, -2, -1},
					   {4, -4, -4, 4, 2, 2, -2, -2, 2, -2, 2, -2, 1, 1, 1, 1}};


void computeCoeff(double *alpha, const double *x) {
	for (int i = 0; i < 16; i++) {
		alpha[i] = 0;
		for (int j = 0; j < 16; j++)
			alpha[i] += A_inv[i][j] * x[j];
	}
}

void compute_coeff(const char *INPUT_FILE_NAME) {
	printf("Computeing coeffs...");
	//float *coeff[2][16];
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < 16; j++)
			coeff[i][j] = new float[INPUT_RESOLUTION * INPUT_RESOLUTION];

	#pragma omp parallel for
	for (int i = 0; i < INPUT_RESOLUTION; i++) {
		for (int j = 0; j < INPUT_RESOLUTION; j++) {
			int x1 = i;
			int y1 = j;
			int x2 = x1 + 1;
			int y2 = y1 + 1;

			double a[16], b[16];
			double xp[16] = {p(x1, y1), p(x2, y1), p(x1, y2), p(x2, y2),
							 px(x1, y1), px(x2, y1), px(x1, y2), px(x2, y2),
							 py(x1, y1), py(x2, y1), py(x1, y2), py(x2, y2),
							 pxy(x1, y1), pxy(x2, y1), pxy(x1, y2), pxy(x2, y2)};
			double xq[16] = {q(x1, y1), q(x2, y1), q(x1, y2), q(x2, y2),
							 qx(x1, y1), qx(x2, y1), qx(x1, y2), qx(x2, y2),
							 qy(x1, y1), qy(x2, y1), qy(x1, y2), qy(x2, y2),
							 qxy(x1, y1), qxy(x2, y1), qxy(x1, y2), qxy(x2, y2)};

			computeCoeff(a, xp);
			computeCoeff(b, xq);

			for (int k = 0; k < 16; k++) {
				coeff[0][k][i * INPUT_RESOLUTION + j] = a[k];
				coeff[1][k][i * INPUT_RESOLUTION + j] = b[k];
			}
		}
	}
	printf("OK\n");

	// Write coeffs to file
	FILE *fp = fopen((string(INPUT_FILE_NAME) + ".coeff").c_str(), "wb");
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < 16; j++)
			fwrite(&coeff[i][j][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
	fclose(fp);
}

void compute_bound(const char *INPUT_FILE_NAME) {
	// TODO:
	// For each patch (i, j), compute the bound in (i, j) - (i + 1, j + 1)
	// Apply search using get_normal(float u, float v)
	FILE *fp = fopen((string(INPUT_FILE_NAME) + ".bound").c_str(), "rb");
	if (!fp) {
		#pragma omp parallel for
		for (int i = 0; i < INPUT_RESOLUTION; i++) {
			for (int j = 0; j < INPUT_RESOLUTION; j++) {
				// Store max in max_n1[i][j], min in min_n1[i][j]
				// Store max in max_n2[i][j], min in min_n2[i][j]
				max_n1[i][j] = max_n2[i][j] = -1e10;
				min_n1[i][j] = min_n2[i][j] = 1e10;
				int max_segs = (1 << MAX_ITER);
				for (int k = 0; k < max_segs; k++) {
					for (int l = 0; l < max_segs; l++) {
						float x1 = ((float) (k) / max_segs + i) / INPUT_RESOLUTION;
						float x2 = ((float) (k + 1) / max_segs + i) / INPUT_RESOLUTION;
						float y1 = ((float) (l) / max_segs + j) / INPUT_RESOLUTION;
						float y2 = ((float) (l + 1) / max_segs + j) / INPUT_RESOLUTION;

						pair<float, float> na = get_normal(x1, y1);
						pair<float, float> nb = get_normal(x1, y2);
						pair<float, float> nc = get_normal(x2, y2);
						pair<float, float> nd = get_normal(x2, y1);

						max_n1[i][j] = max(max_n1[i][j], max4(na.first, nb.first, nc.first, nd.first));
						min_n1[i][j] = min(min_n1[i][j], min4(na.first, nb.first, nc.first, nd.first));
						max_n2[i][j] = max(max_n2[i][j], max4(na.second, nb.second, nc.second, nd.second));
						min_n2[i][j] = min(min_n2[i][j], min4(na.second, nb.second, nc.second, nd.second));
					}
				}
			}
			printf("Precomputing bounding box, row %d ... OK\n", i);
		}
		fp = fopen((string(INPUT_FILE_NAME) + ".bound").c_str(), "wb");
		fwrite(&max_n1[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fwrite(&min_n1[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fwrite(&max_n2[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fwrite(&min_n2[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fclose(fp);

	} else {
		fread(&max_n1[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fread(&min_n1[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fread(&max_n2[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fread(&min_n2[0][0], sizeof(float), INPUT_RESOLUTION * INPUT_RESOLUTION, fp);
		fclose(fp);
	}
	printf("Precomputing bounding box finished!\n");
}

